#pragma once

#include "TUSB16AD.h"
#include "DevForm.h"

namespace My0216ADMSample {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^[ R[hǉ܂
			//
			DevStatus = gcnew array<Boolean>(16);
			IdDevForm = gcnew array<DevForm^>(16);
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	internal: System::Windows::Forms::Button^  OpenBtn;
	protected: 
	internal: System::Windows::Forms::ComboBox^  DevIdSel;
	public: System::Windows::Forms::Button^  EndAppBtn;
	internal: 
	internal: System::Windows::Forms::Timer^  Timer1;
	public: 
	private: System::ComponentModel::IContainer^  components;
	internal: 

	private:
		/// <summary>
		/// KvȃfUCi[ϐłB
		/// </summary>
		array<Boolean>^ DevStatus;// Device Connection Flag TRUE : connecting
		array<DevForm^>^ IdDevForm;//Device Control Panel Form Object


#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi[ T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^[ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->OpenBtn = (gcnew System::Windows::Forms::Button());
			this->DevIdSel = (gcnew System::Windows::Forms::ComboBox());
			this->EndAppBtn = (gcnew System::Windows::Forms::Button());
			this->Timer1 = (gcnew System::Windows::Forms::Timer(this->components));
			this->SuspendLayout();
			// 
			// OpenBtn
			// 
			this->OpenBtn->Location = System::Drawing::Point(149, 100);
			this->OpenBtn->Name = L"OpenBtn";
			this->OpenBtn->Size = System::Drawing::Size(109, 32);
			this->OpenBtn->TabIndex = 90;
			this->OpenBtn->Text = L"Open";
			this->OpenBtn->UseVisualStyleBackColor = true;
			this->OpenBtn->Click += gcnew System::EventHandler(this, &Form1::OpenBtn_Click);
			// 
			// DevIdSel
			// 
			this->DevIdSel->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->DevIdSel->FormattingEnabled = true;
			this->DevIdSel->Items->AddRange(gcnew cli::array< System::Object^  >(16) {L"0", L"1", L"2", L"3", L"4", L"5", L"6", L"7", 
				L"8", L"9", L"A", L"B", L"C", L"D", L"E", L"F"});
			this->DevIdSel->Location = System::Drawing::Point(26, 112);
			this->DevIdSel->Name = L"DevIdSel";
			this->DevIdSel->Size = System::Drawing::Size(66, 20);
			this->DevIdSel->TabIndex = 89;
			// 
			// EndAppBtn
			// 
			this->EndAppBtn->BackColor = System::Drawing::SystemColors::Control;
			this->EndAppBtn->Cursor = System::Windows::Forms::Cursors::Default;
			this->EndAppBtn->ForeColor = System::Drawing::SystemColors::ControlText;
			this->EndAppBtn->Location = System::Drawing::Point(78, 31);
			this->EndAppBtn->Name = L"EndAppBtn";
			this->EndAppBtn->RightToLeft = System::Windows::Forms::RightToLeft::No;
			this->EndAppBtn->Size = System::Drawing::Size(129, 41);
			this->EndAppBtn->TabIndex = 88;
			this->EndAppBtn->Text = L"I";
			this->EndAppBtn->UseVisualStyleBackColor = false;
			this->EndAppBtn->Click += gcnew System::EventHandler(this, &Form1::EndAppBtn_Click);
			// 
			// Timer1
			// 
			this->Timer1->Tick += gcnew System::EventHandler(this, &Form1::Timer1_Tick);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(284, 162);
			this->Controls->Add(this->OpenBtn);
			this->Controls->Add(this->DevIdSel);
			this->Controls->Add(this->EndAppBtn);
			this->Name = L"Form1";
			this->Text = L"TUSB-0216ADM Sample Program";
			this->FormClosed += gcnew System::Windows::Forms::FormClosedEventHandler(this, &Form1::Form1_FormClosed);
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
			short DevId;

			Timer1->Interval = 300;
			Timer1->Enabled = true;

			DevIdSel->SelectedIndex = 0;

			// Initialize
			for( DevId = 0 ; DevId < 16 ; DevId++ )
			{
				DevStatus[DevId] = false; // Device is not Connected
			}
			 }
private: System::Void Form1_FormClosed(System::Object^  sender, System::Windows::Forms::FormClosedEventArgs^  e) {
            short DevId;

            Timer1->Enabled = false;
            for( DevId = 0 ; DevId < 16 ; DevId++ )
            {
                if (IdDevForm[DevId] != nullptr)
                {
                    if (IdDevForm[DevId]->Visible)
                    {
                        IdDevForm[DevId]->Close();
                        DevStatus[DevId] = false;
                        TUSB0216AD_Device_Close(DevId);
                    }
				}
            }
		 }
private: void OpenPanel(short Id)
		 {
            DevStatus[Id] = true;
            IdDevForm[Id] = gcnew DevForm();// Device Control Panel Form Create
            IdDevForm[Id]->SetId(Id);
            IdDevForm[Id]->Show();// Form Show
		 }
private: System::Void OpenBtn_Click(System::Object^  sender, System::EventArgs^  e) {
            short DevId;

            DevId = (short) DevIdSel->SelectedIndex;
            if( DevStatus[DevId] == false )// Device is not connected
            {
                if( TUSB0216AD_Device_Open(DevId) == 0 )// Connection check
                    OpenPanel(DevId);
            }
		 }
private: System::Void Timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
            short DevId;

            for( DevId = 0 ; DevId < 16 ; DevId++ )
            {
                if( DevStatus[DevId] )
                {
                    if( IdDevForm[DevId]->Visible == false ) // Device is not visible
                    {
                        TUSB0216AD_Device_Close(DevId);
                        DevStatus[DevId] = false;
                    }
                }
            }
		 }
private: System::Void EndAppBtn_Click(System::Object^  sender, System::EventArgs^  e) {
			 this->Close();
		 }
};
}

